## hhvm 3.11.1+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)

# This needs to be done before any languages are enabled or
# projects are created.
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/CMake/VisualStudioToolset.cmake")

# includes
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# package information
SET(PACKAGE_NAME      "hhvm")
SET(PACKAGE_VERSION   "3.11.1")
SET(PACKAGE_STRING    "${PACKAGE_NAME} ${PACKAGE_VERSION}")
SET(PACKAGE_TARNAME   "${PACKAGE_NAME}-${PACKAGE_VERSION}")
SET(PACKAGE_BUGREPORT "https://github.com/facebook/hhvm/issues")

PROJECT(${PACKAGE_NAME} C CXX ASM)
if (MSVC)
  enable_language(ASM_MASM)
endif()

MARK_AS_ADVANCED(CLEAR CMAKE_INSTALL_PREFIX)
IF(APPLE)
  # CMake really likes finding libraries inside OS X frameworks. This can
  # create super unexpected results, such as the LDAP framework, where the
  # ldap.h header there just consists of "#include <ldap.h>" -- obviously
  # assuming /usr/include appears on the include path before that framework
  # (which wasn't really supposed to be on the include path at all). This
  # leads to a hilarious recursive include and general fireworks. Instead,
  # tell CMake to search frameworks *last*, if it doesn't find something in
  # /usr (or MacPorts/Homebrew).
  SET(CMAKE_FIND_FRAMEWORK "LAST")
  MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES
    CMAKE_OSX_DEPLOYMENT_TARGET
    CMAKE_OSX_SYSROOT)
ENDIF()

# Check architecture OS
IF(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
  MESSAGE(FATAL_ERROR "HHVM requires a 64bit OS")
ENDIF()

# 3rd party library
IF(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third-party/CMakeLists.txt")
  MESSAGE(FATAL_ERROR "third-party/CMakeLists.txt missing. "
                      "Try updating your submodule with:
rm -r third-party
git submodule update --init --recursive
")
ENDIF()

INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/CMake/HPHPFunctions.cmake")
INCLUDE(CheckFunctionExists)

SET(HPHP_HOME ${CMAKE_CURRENT_SOURCE_DIR})
SET(TP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/third-party")
SET(TP_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/third-party")

ADD_SUBDIRECTORY(third-party)
ADD_SUBDIRECTORY(hphp)

# use GNU install dirs (e.g. lib64 instead of lib)
INCLUDE(GNUInstallDirs)

# modules / depends
FILE(GLOB HHVM_CMAKE_FILES "CMake/*.cmake")
INSTALL(
  FILES ${HHVM_CMAKE_FILES}
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
  COMPONENT dev)

=== hphp/CMakeLists.txt ===
#
#   +----------------------------------------------------------------------+
#   | HipHop for PHP                                                       |
#   +----------------------------------------------------------------------+
#   | Copyright (c) 2010 Facebook, Inc. (http://www.facebook.com)          |
#   | Copyright (c) 1997-2010 The PHP Group                                |
#   +----------------------------------------------------------------------+
#   | This source file is subject to version 3.01 of the PHP license,      |
#   | that is bundled with this package in the file LICENSE, and is        |
#   | available through the world-wide-web at the following url:           |
#   | http://www.php.net/license/3_01.txt                                  |
#   | If you did not receive a copy of the PHP license and are unable to   |
#   | obtain it through the world-wide-web, please send a note to          |
#   | license@php.net so we can mail you a copy immediately.               |
#   +----------------------------------------------------------------------+
#

if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/facebook")
  # I'm sorry, but facebook's internal repo has the top level dir stored inside
  # of hphp/, so we need to pull that one in first if it exists
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)
  set(HPHP_HOME ${CMAKE_CURRENT_SOURCE_DIR}/..)
  set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/facebook/CMake"
                        "${CMAKE_CURRENT_SOURCE_DIR}/public_tld/CMake"
                        ${CMAKE_MODULE_PATH})
  include(FBTLD)
endif()

include(HPHPSetup)
include(FollySetup)
if (ENABLE_COTIRE)
  include(cotire)
  FIND_PATH(LIBC_INCLUDE_PATH stdlib.h)

  # Detect the architecture-specific include directory
  IF("${CMAKE_LIBRARY_ARCHITECTURE}" STREQUAL "")
    # For CentOS/Red Hat where they store it directly in /usr/include
    SET(ARCH_INCLUDE_PATH "${LIBC_INCLUDE_PATH}/bits")
  ELSE()
    FIND_PATH(ARCH_INCLUDE_PATH ${CMAKE_LIBRARY_ARCHITECTURE})
    SET(ARCH_INCLUDE_PATH "${ARCH_INCLUDE_PATH}/${CMAKE_LIBRARY_ARCHITECTURE}")
  ENDIF()

  set_property(DIRECTORY
    PROPERTY COTIRE_PREFIX_HEADER_IGNORE_PATH
      "${LIBC_INCLUDE_PATH}/stdlib.h"
      "${LIBC_INCLUDE_PATH}/string.h"
      "${LIBC_INCLUDE_PATH}/ansidecl.h"
      "${LIBC_INCLUDE_PATH}/bfd.h"
      "${LIBC_INCLUDE_PATH}/libelf.h"
      "${LIBC_INCLUDE_PATH}/elf.h"
      "${LIBC_INCLUDE_PATH}/gelf.h"
      "${ARCH_INCLUDE_PATH}"
      "${CCLIENT_INCLUDE_PATH}"
      "${JEMALLOC_INCLUDE_DIR}/jemalloc"
      "${ONIGURUMA_INCLUDE_DIR}/onigposix.h"
      "${ONIGURUMA_INCLUDE_DIR}/oniguruma.h"
      "${LIBPNG_INCLUDE_DIRS}/png.h"
      "${LDAP_INCLUDE_DIR}/ldap.h"
      "${CMAKE_SOURCE_DIR}"
      "${CMAKE_BINARY_DIR}")
endif()

# Only thing to do directly in tools is install this one script. Tools also has
# its own Makefile, so just do it here instead of dealing with moving that all
# around.
install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/tools/oss-repo-mode
  RENAME hhvm-repo-mode
  DESTINATION bin
  COMPONENT dev)

add_definitions("-DHHVM")
add_definitions("-DUSE_CMAKE")

enable_language(ASM)

add_subdirectory(tools/bootstrap)
add_subdirectory(tools/hfsort)
add_subdirectory(tools/version)
add_subdirectory(tools/tc-print)

add_subdirectory(compiler)
add_subdirectory(hack)
add_subdirectory(hhbbc)
add_subdirectory(neo)
add_subdirectory(parser)

add_subdirectory(runtime)
add_subdirectory(runtime/ext)
add_subdirectory(runtime/ext_hhvm)
if (ENABLE_ZEND_COMPAT)
  add_subdirectory(runtime/ext_zend_compat)
endif()
add_subdirectory(system)
add_subdirectory(util)
add_subdirectory(ppc64-asm)
add_subdirectory(vixl)
add_subdirectory(zend)

add_subdirectory(hhvm)

option(TEST_BIN "Create the HHVM test binary" OFF)
if (TEST_BIN)
  add_subdirectory(test)
endif ()

add_subdirectory(tools/gdb)

# Keep this last
add_subdirectory(tools/hphpize)

=== hphp/hack/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)

find_package(OCaml)
find_package(LZ4)
find_package(LibElf)
find_package(Memfd)

if (OCAMLC_FOUND)
  # This is totally the wrong way to do this, but I am tired of fighting with
  # build systems and don't really care to make this work the right way. libelf
  # and lz4 are all we need right now anyways.
  unset(extra_include_paths)
  unset(extra_lib_paths)
  unset(extra_cc_flags)

  # Allows '#include "hphp/path/to/library/"' paths to start from hphp
  # project directory  which is consistent with fbmake's include paths.
  list(APPEND extra_include_paths ${HPHP_HOME})

  foreach(lib ${LIBELF_INCLUDE_DIRS})
    list(APPEND extra_include_paths ${lib})
  endforeach()
  if(ELF_GETSHDRSTRNDX)
    list(APPEND extra_cc_flags -DHAVE_ELF_GETSHDRSTRNDX)
  endif()

  if(HAVE_MEMFD_CREATE)
    list(APPEND extra_cc_flags -DHAVE_MEMFD_CREATE)
  endif()

  if(HAVE_DECL___NR_MEMFD_CREATE)
    list(APPEND extra_cc_flags -DHAVE_DECL___NR_MEMFD_CREATE)
  endif()

  list(APPEND extra_cc_flags -DOSS_SMALL_HH_TABLE_POWS)
  list(APPEND extra_cc_flags -pthread)

  foreach(lib ${LIBELF_LIBRARIES})
    get_filename_component(pth ${lib} PATH)
    list(APPEND extra_lib_paths ${pth})
  endforeach()

  if(LZ4_FOUND)
    list(APPEND extra_include_paths ${LZ4_INCLUDE_DIR})
    get_filename_component(pth ${LZ4_LIBRARY} PATH)
    list(APPEND extra_lib_paths ${pth})
  else()
    list(APPEND extra_include_paths "${TP_DIR}/lz4")
    list(APPEND extra_lib_paths "${TP_BUILD_DIR}/lz4")
  endif()
  list(APPEND extra_native_libraries "lz4")

  # Xcode/Ninja generators undefined MAKE
  if(NOT MAKE)
    set(MAKE make)
  endif()

  add_custom_target(
    hack
    ALL
    COMMAND
      env OPTBIN="${OCAMLC_OPT_SUFFIX}"
          $(MAKE) EXTRA_INCLUDE_PATHS="${extra_include_paths}"
          EXTRA_LIB_PATHS="${extra_lib_paths}"
          EXTRA_CC_FLAGS="${extra_cc_flags}"
          EXTRA_NATIVE_LIBRARIES="${extra_native_libraries}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
  )

  add_custom_target(
    hack_test
    COMMAND
      env OPTBIN="${OCAMLC_OPT_SUFFIX}"
          $(MAKE) test EXTRA_INCLUDE_PATHS="${extra_include_paths}"
          EXTRA_LIB_PATHS="${extra_lib_paths}"
          EXTRA_CC_FLAGS="${extra_cc_flags}"
          EXTRA_NATIVE_LIBRARIES="${extra_native_libraries}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
  )

  if(NOT LZ4_FOUND)
    # if the system does not have lz4, make sure that the one in public_tld
    # gets built
    add_dependencies(hack lz4)
    add_dependencies(hack_test lz4)
  endif()

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_client
    DESTINATION bin
    COMPONENT dev)

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_server
    DESTINATION bin
    COMPONENT dev)

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_format
    DESTINATION bin
    COMPONENT dev)

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/h2tp
    DESTINATION bin
    COMPONENT dev)

  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/h2tp/resources/
    DESTINATION share/hhvm/hack/hacklib
    COMPONENT dev)
endif()

=== hphp/neo/CMakeLists.txt ===
set(C_SOURCES)
auto_sources(files "*.c" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND C_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "RECURSE")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(neo ${files})

add_library(neo STATIC ${C_SOURCES} ${HEADER_SOURCES})
auto_source_group("neo" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${C_SOURCES} ${HEADER_SOURCES})

if (ENABLE_COTIRE)
  cotire(neo)
endif()

=== hphp/parser/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(parser ${files})

add_library(hphp_parser STATIC ${CXX_SOURCES} ${HEADER_SOURCES})
auto_source_group("hphp_parser" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${CXX_SOURCES} ${HEADER_SOURCES})

if (ENABLE_COTIRE)
  cotire(hphp_parser)
endif()

=== hphp/ppc64-asm/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

add_library(ppc64-asm STATIC ${CXX_SOURCES})

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
HHVM_PUBLIC_HEADERS(ppc64-asm ${files})

=== hphp/system/CMakeLists.txt ===
foreach(def ${EXTENSION_IDL_DEFINES})
  add_definitions(${def})
endforeach()

# This will be run after runtime/ext has, so we can use the output of
# that.
add_custom_command(
  OUTPUT "class_map.cpp" "constants.h"
  DEPENDS ${IDL_SRCS} gen-class-map
  COMMAND gen-class-map
  ARGS "--system"
       "${CMAKE_CURRENT_BINARY_DIR}/class_map.cpp"
       "${CMAKE_CURRENT_BINARY_DIR}/constants.h"
       "${CMAKE_CURRENT_SOURCE_DIR}/idl/constants.idl.json"
       ${EXTENSION_IDL_SOURCES}
  COMMENT "Generating class_map.cpp and constants.h")

set(CXX_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/class_map.cpp"
                "systemlib.cpp")

add_library(hphp_system STATIC ${CXX_SOURCES})
if (ENABLE_ASYNC_MYSQL)
  add_dependencies(hphp_system webscalesqlclient)
endif ()

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
# constants.h doesn't exist until build time,
# so we need to manually inject it here
list(APPEND files "${CMAKE_CURRENT_BINARY_DIR}/constants.h")
HHVM_PUBLIC_HEADERS(system ${files})

# Needed to force system/constants.h to generate prior to files which need it
if (ENABLE_ZEND_COMPAT)
  add_dependencies(hphp_ext_zend_compat hphp_system)
endif()

add_dependencies(hphp_runtime_static hphp_system)
add_dependencies(hphp_runtime_ext hphp_system)
add_dependencies(hphp_analysis hphp_system)

FILE(STRINGS "php.txt" SYSTEMLIB_CLASSES)
set(SYSTEMLIB_SRCS)
set(SYSTEMLIB_SRCS_STR)
foreach(cls ${SYSTEMLIB_CLASSES})
  STRING(REGEX REPLACE "[ \t]*#.*" "" cls "${cls}")
  if (NOT "${cls}" STREQUAL "")
    list(APPEND SYSTEMLIB_SRCS "../../${cls}")
    set(SYSTEMLIB_SRCS_STR "${SYSTEMLIB_SRCS_STR} ${cls}")
  endif()
endforeach()

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/systemlib.php
  DEPENDS "php.txt" ${SYSTEMLIB_SRCS}
  COMMAND "INSTALL_DIR=${CMAKE_CURRENT_BINARY_DIR}"
          "FBCODE_DIR=${CMAKE_CURRENT_SOURCE_DIR}/../.."
          "${CMAKE_CURRENT_SOURCE_DIR}/make_systemlib.sh"
          "--install_dir=${CMAKE_CURRENT_BINARY_DIR}"
          "--fbcode_dir=${CMAKE_CURRENT_SOURCE_DIR}/.."
          "${SYSTEMLIB_SRCS_STR}"
  COMMENT "Generating systemlib.php")

add_custom_target(
  systemlib
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/systemlib.php)

=== hphp/util/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

set(ASM_SOURCES)
auto_sources(files "*.S" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND ASM_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "RECURSE")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(util ${files})

# Disable Channeled JSON until we're sure it's going to stick
# sgolemon(2014-02-19)
HHVM_REMOVE_MATCHES_FROM_LISTS(ASM_SOURCES CXX_SOURCES HEADER_SOURCES
  MATCHES "/test/" "channeled-json-")

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-repo-schema.h"
         "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-build-info.cpp"
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/generate-buildinfo.sh"
  DEPENDS ${CXX_SOURCES}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
  COMMENT "Generating Repo Schema ID and Compiler ID"
  VERBATIM)

## Disabling numa support (for now) since distro
## libnuma packages don't always have numa_init available
## Find a better way to make sure numa initialization
## happens on time. -sgolemon (2013-10-16)

#find_package(LibNuma)
#if (LIBNUMA_INCLUDE_DIRS)
#  add_definitions("-DHAVE_NUMA=1")
#  include_directories(${LIBNUMA_INCLUDE_DIRS})
#endif()

if(MSVC)
  list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.cpp")
  list(REMOVE_ITEM HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.h")
  list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/light-process.cpp")
  list(REMOVE_ITEM HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/light-process.h")
endif()

add_library(hphp_util STATIC ${CXX_SOURCES} ${ASM_SOURCES} ${HEADER_SOURCES}
            "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-repo-schema.h"
            "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-build-info.cpp")
auto_source_group("hphp_util" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${ASM_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})
if (ENABLE_COTIRE)
  cotire(hphp_util)
endif()

#if (LIBNUMA_LIBRARIES)
#  target_link_libraries(hphp_util ${LIBNUMA_LIBRARIES})
#endif()
if (ENABLE_ASYNC_MYSQL)
  add_dependencies(hphp_util webscalesqlclient)
endif ()

=== hphp/vixl/CMakeLists.txt ===
set(CXX_SOURCES)
set(HEADER_SOURCES)

auto_sources(files "*.cc" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

if(NOT IS_AARCH64)
  add_definitions("-DUSE_SIMULATOR")
endif()

auto_sources(files "*.cc" "${CMAKE_CURRENT_SOURCE_DIR}/a64")
list(APPEND CXX_SOURCES ${files})

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(vixl ${files})

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}/a64")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(vixl ${files})

add_library(vixl STATIC ${CXX_SOURCES} ${HEADER_SOURCES})
auto_source_group("vixl" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${CXX_SOURCES} ${HEADER_SOURCES})

=== hphp/zend/CMakeLists.txt ===
set(C_SOURCES)
auto_sources(files "*.c" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND C_SOURCES ${files})

set(CXX_SOURCES)
auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "RECURSE")
list(APPEND HEADER_SOURCES ${files})

if (NOT MSVC)
  list(REMOVE_ITEM C_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/crypt-freesec.c
    ${CMAKE_CURRENT_SOURCE_DIR}/crypt-sha256.c
    ${CMAKE_CURRENT_SOURCE_DIR}/crypt-sha512.c
    ${CMAKE_CURRENT_SOURCE_DIR}/php-crypt_r.c
  )
  list(REMOVE_ITEM HEADER_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/crypt-freesec.h
    ${CMAKE_CURRENT_SOURCE_DIR}/php-crypt_r.h
  )
endif()

HHVM_PUBLIC_HEADERS(zend ${HEADER_SOURCES})

add_library(hphp_zend STATIC ${C_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})
auto_source_group("hphp_zend" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${C_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})

=== third-party/fastlz/CMakeLists.txt ===
add_library(fastlz STATIC fastlz.c)

=== third-party/folly/CMakeLists.txt ===
set(FOLLY_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/folly")

# Needed for fcntl w/ F_SETPIPE_SZ
add_definitions("-D_GNU_SOURCE")

# Ensure that we are either getting malloc functions
# like malloc_usable_size() from either malloc.h
# or stdlib.h. Default is stdlib.h
INCLUDE(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("#include <malloc.h>
int main() {
  return 0;
}" FOLLY_MALLOC)
if (FOLLY_MALLOC)
  add_definitions("-DFOLLY_HAVE_MALLOC_H=1")
else()
  add_definitions("-DFOLLY_HAVE_MALLOC_H=0")
endif()

if (NOT EXISTS "${FOLLY_DIR}/Portability.h")
  message(FATAL_ERROR "${FOLLY_DIR}/Portability.h missing, did you forget to "
                      "run `git submodule update --init --recursive`?")
endif()

add_definitions(-DNO_LIB_GFLAGS)

# Generated files from folly/build/generate_*.py
auto_sources(genfiles "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}/gen")

# Main folly library files
auto_sources(files "*.cpp" "RECURSE" "${FOLLY_DIR}")
auto_sources(cfiles "*.c" "RECURSE" "${FOLLY_DIR}")

# No need for tests, Benchmarks, Utils, or most experimental stuff
foreach (file ${files})
  if (${file} MATCHES "/test/")
    list(REMOVE_ITEM files ${file})
  endif()
  if (${file} MATCHES "Test.cpp$")
    list(REMOVE_ITEM files ${file})
  endif()
  if (${file} MATCHES "/futures/exercises/")
    list(REMOVE_ITEM files ${file})
  endif()
endforeach()
list(REMOVE_ITEM files
  ${FOLLY_DIR}/Benchmark.cpp
  ${FOLLY_DIR}/build/GenerateFingerprintTables.cpp
  ${FOLLY_DIR}/detail/Clock.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/ExceptionTracer.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/ExceptionTracerBenchmark.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/ExceptionTracerLib.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/StackTrace.cpp
  ${FOLLY_DIR}/experimental/JSONSchemaTester.cpp
  ${FOLLY_DIR}/experimental/io/AsyncIO.cpp
  ${FOLLY_DIR}/experimental/io/HugePageUtil.cpp
  ${FOLLY_DIR}/experimental/io/IOBufQueue.cpp
  ${FOLLY_DIR}/experimental/ProgramOptions.cpp
  ${FOLLY_DIR}/experimental/symbolizer/StackTrace.cpp
  ${FOLLY_DIR}/experimental/symbolizer/ElfCache.cpp
  ${FOLLY_DIR}/experimental/symbolizer/ElfUtil.cpp
  ${FOLLY_DIR}/experimental/symbolizer/SignalHandler.cpp
  ${FOLLY_DIR}/experimental/TestUtil.cpp
  ${FOLLY_DIR}/SingletonStackTrace.cpp
  )

CHECK_CXX_SOURCE_COMPILES("#include <bits/functexcept.h>
int main() {
  return 0;
}" FOLLY_FUNCTEXCEPT)
if (FOLLY_FUNCTEXCEPT)
  list(REMOVE_ITEM files
    ${FOLLY_DIR}/detail/FunctionalExcept.cpp
  )
endif()

# Remove non-portable items
if (NOT LINUX)
  list(REMOVE_ITEM files
    ${FOLLY_DIR}/experimental/symbolizer/Symbolizer.cpp
    ${FOLLY_DIR}/experimental/symbolizer/Dwarf.cpp
    ${FOLLY_DIR}/experimental/symbolizer/Elf.cpp
    )
endif()

# io/Compression requires snappy library
# Don't add dep until we need it
list(REMOVE_ITEM files ${FOLLY_DIR}/io/Compression.cpp)

add_library(folly STATIC ${files} ${genfiles} ${cfiles} )

find_package(Boost 1.51.0 COMPONENTS system program_options filesystem regex
             context REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

find_package(Glog REQUIRED)
include_directories(${LIBGLOG_INCLUDE_DIR})

find_package(PThread REQUIRED)
include_directories(${LIBPTHREAD_INCLUDE_DIRS})

target_link_libraries(folly ${Boost_LIBRARIES}
                            ${LIBGLOG_LIBRARY}
                            ${LIBPTHREAD_LIBRARIES})

if (DOUBLE_CONVERSION_LIBRARY)
  target_link_libraries(folly ${DOUBLE_CONVERSION_LIBRARY})
else()
  target_link_libraries(folly double-conversion)
endif()

if (JEMALLOC_ENABLED)
  target_link_libraries(folly ${JEMALLOC_LIB})
endif()

# For some reason we aren't making a folly-config.h and this is in there.
# Please fix properly!
add_definitions("-DFOLLY_VERSION=\"0.1\"")

=== debian/changelog ===
hhvm (3.11.1+dfsg-1ubuntu1) xenial; urgency=medium

  * Rebuild against libmysqlclient20.
  * d/p/libmysqlclient_r: build against libmysqlclient, not _r (LP:
    #1564871).
  * d/p/isnan: use std:: for isnan and isinf to fix FTBFS.

 -- Robie Basak <robie.basak@ubuntu.com>  Mon, 18 Apr 2016 13:54:43 +0000

hhvm (3.11.1+dfsg-1) unstable; urgency=medium

  * New minor upstream release.
  * Build-depend on libpng-dev instead of libpng12-dev for the upcoming libpng
    transition. (Closes: #809873)
  * More reproducible fixes:
    - Create Hack's HHI tarball in a reproducible way.
    - Statically set HHVM_REPO_SCHEMA from debian/rules.
    - Pass LC_ALL=C to sort as called by proxygen's header generation script.
  * Add patch output-buffer-fix-flush, copied straight from upstream's GitHub,
    to large output streaming.
  * Update Vcs-Git and Vcs-Browser URLs for HTTPS and cgit.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 03 Feb 2016 20:21:13 +0200

=== debian/control ===
Source: hhvm
Section: php
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HHVM packaging team <pkg-hhvm-team@lists.alioth.debian.org>
Uploaders: David Martínez Moreno <ender@debian.org>, Faidon Liambotis <paravoid@debian.org>
Build-Depends: debhelper (>= 9.0.0),
  autotools-dev,
  binutils-dev,
  bison,
  chrpath,
  cmake,
  flex,
  gawk,
  gperf,
  libboost-dev,
  libboost-context-dev,
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-regex-dev,
  libboost-system-dev,
  libboost-thread-dev,
  libbz2-dev,
  libcap-dev,
  libc-client2007e-dev,
  libcurl4-openssl-dev,
  libdouble-conversion-dev,
  libdwarf-dev,
  libedit-dev,
  libelf-dev,
  libevent-dev,
  libexpat1-dev,
  libfreetype6-dev,
  libgmp-dev,
  libgoogle-glog-dev,
  libiberty-dev,
  libicu-dev,
  libinotifytools0-dev,
  libjemalloc-dev,
  libjpeg-dev,
  libjson-c-dev,
  libldap2-dev,
  liblz4-dev,
  libmagickcore-dev,
  libmagickwand-dev,
  libmcrypt-dev,
  libmemcached-dev,
  libmysqlclient-dev,
  libonig-dev,
  libpcre3-dev,
  libpng-dev,
  libre2-dev,
  libsqlite3-dev,
  libssl-dev,
  libtbb-dev,
  libvpx-dev,
  libxml2-dev,
  libxslt1-dev,
  libyaml-dev,
  libzip-dev (>= 0.11),
  ocaml-native-compilers,
  pkg-config,
  unixodbc-dev,
  zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://hhvm.com/
Vcs-Git: https://anonscm.debian.org/git/pkg-hhvm/hhvm.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hhvm/hhvm.git

Package: hhvm
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${hhvm:ApiVersion}
Description: HipHop Virtual Machine, a JIT replacement for PHP - main runtime
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.

Package: hhvm-dbg
Architecture: amd64
Depends: hhvm (= ${binary:Version}), python, ${misc:Depends}
Recommends: gdb
Section: debug
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - debugging symbols
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the debugging symbols for HHVM.

Package: hhvm-dev
Architecture: amd64
Depends: ${misc:Depends}, cmake
Section: libdevel
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - development files
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the header & build system files needed for compiling
 HHVM extensions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
# To prevent bogus linkage.
LDFLAGS += -Wl,--as-needed

# used to store HHBC during tests
BUILDHOME = $(CURDIR)/debian/build

# Exported variable to make sure that we don't use cursor control in the tests.
export TRAVIS = bogus

# Contrary to its confusing name, this is actually the build's revision ID.
# hphp/util/generate-buildinfo.sh uses:
#   $COMPILER_ID -> git describe -> hg log -> date
# We want to avoid relying on git (because we may building from the .dsc) and
# date (because that would add variance to the build)
export COMPILER_ID = $(shell dpkg-parsechangelog -SVersion)

# same with the repo schema, which uniquely identifies a build; the script
# takes some variance into account, possibly from CMakeFiles; it also operates
# differently when under git, so make it just a hash of the Debian version.
export HHVM_REPO_SCHEMA = $(shell dpkg-parsechangelog -SVersion | sha1sum | cut -b-40)

%:
	dh $@ --parallel

override_dh_auto_build:
	# rerun flex/bison to regenerate their output for DFSG reasons
	./hphp/parser/make-lexer.sh
	./hphp/parser/make-parser.sh
	VERBOSE=1 dh_auto_build

override_dh_auto_configure:
	printenv
	echo $(LDFLAGS)
	dh_auto_configure -- \
		-DUSE_JSONC=ON \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2/ \
		-DENABLE_ASYNC_MYSQL=OFF \
		-DMYSQL_UNIX_SOCK_ADDR=/dev/null \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	# HHVM by default uses ~/.hhvm.hhbc, but ~ isn't guranteed to exist.
	-mkdir $(BUILDHOME)
	HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m jit quick
	HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m interp quick
endif

override_dh_clean:
	dh_clean
	-rm -rf $(BUILDHOME)

override_dh_gencontrol:
	# see hphp/runtime/version.h, HHVM_VERSION_BRANCH
	hhvmapi=$(shell $(CURDIR)/debian/hhvm/usr/bin/hhvm --version | sed -ne 's/^HipHop VM \(.*\)\..*/\1/p') && \
		[ -n "$${hhvmapi}" ] && echo "hhvm:ApiVersion=hhvm-api-$${hhvmapi}" >> debian/hhvm.substvars
	dh_gencontrol

override_dh_strip:
	dh_strip --dbg-package=hhvm-dbg

override_dh_fixperms:
	dh_fixperms
	chown www-data:www-data \
		$(CURDIR)/debian/hhvm/var/cache/hhvm

## hhvm 3.12.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 # package information
 SET(PACKAGE_NAME      "hhvm")
-SET(PACKAGE_VERSION   "3.11.1")
+SET(PACKAGE_VERSION   "3.12.1")
 SET(PACKAGE_STRING    "${PACKAGE_NAME} ${PACKAGE_VERSION}")
 SET(PACKAGE_TARNAME   "${PACKAGE_NAME}-${PACKAGE_VERSION}")
 SET(PACKAGE_BUGREPORT "https://github.com/facebook/hhvm/issues")
@@ -57,6 +57,8 @@
 SET(TP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/third-party")
 SET(TP_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/third-party")
 
+include(MSVCDefaults)
+
 ADD_SUBDIRECTORY(third-party)
 ADD_SUBDIRECTORY(hphp)

=== hphp/util/CMakeLists.txt ===
--- 
+++ 
@@ -7,14 +7,32 @@
 list(APPEND ASM_SOURCES ${files})
 
 set(HEADER_SOURCES)
-auto_sources(files "*.h" "RECURSE")
+auto_sources(files "*.h" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
 list(APPEND HEADER_SOURCES ${files})
-HHVM_PUBLIC_HEADERS(util ${files})
 
 # Disable Channeled JSON until we're sure it's going to stick
 # sgolemon(2014-02-19)
 HHVM_REMOVE_MATCHES_FROM_LISTS(ASM_SOURCES CXX_SOURCES HEADER_SOURCES
   MATCHES "/test/" "channeled-json-")
+
+if (NOT MSVC)
+  list(REMOVE_ITEM CXX_SOURCES
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/fnmatch.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/glob.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/rand_r.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strfmon.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strptime.cpp
+  )
+  list(REMOVE_ITEM HEADER_SOURCES
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/fnmatch.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/glob.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/rand_r.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strfmon.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strptime.h
+  )
+endif()
+
+HHVM_PUBLIC_HEADERS(util ${HEADER_SOURCES})
 
 add_custom_command(
   OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-repo-schema.h"
@@ -25,16 +43,11 @@
   COMMENT "Generating Repo Schema ID and Compiler ID"
   VERBATIM)
 
-## Disabling numa support (for now) since distro
-## libnuma packages don't always have numa_init available
-## Find a better way to make sure numa initialization
-## happens on time. -sgolemon (2013-10-16)
-
-#find_package(LibNuma)
-#if (LIBNUMA_INCLUDE_DIRS)
-#  add_definitions("-DHAVE_NUMA=1")
-#  include_directories(${LIBNUMA_INCLUDE_DIRS})
-#endif()
+find_package(LibNuma)
+if (LIBNUMA_INCLUDE_DIRS)
+  add_definitions("-DHAVE_NUMA=1")
+  include_directories(${LIBNUMA_INCLUDE_DIRS})
+endif()
 
 if(MSVC)
   list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.cpp")
@@ -52,9 +65,9 @@
   cotire(hphp_util)
 endif()
 
-#if (LIBNUMA_LIBRARIES)
-#  target_link_libraries(hphp_util ${LIBNUMA_LIBRARIES})
-#endif()
+if (LIBNUMA_LIBRARIES AND JEMALLOC_ENABLED)
+  target_link_libraries(hphp_util ${LIBNUMA_LIBRARIES})
+endif()
 if (ENABLE_ASYNC_MYSQL)
   add_dependencies(hphp_util webscalesqlclient)
 endif ()
